Date: 2019-06-17
Title: The homebrewserver.club principles
url: index.html
save_as: index.html
Summary: The homebrewserver.club principles
Status: published
Category: fundamentals
slug: 006

[TOC]

## Promote approaches, not apps  
We privilege general approaches over particular software applications. We try to contextualize our technical choices socially, politically and economically to provide in-depth understanding and prevent The Best Way™ solutionism. For these reasons we like free and open source software as a starting point and try to provide documentation for others to learn as well.

## Take the ‘home’ in homebrewserver.club literally and the ‘self’ in self-hosting figuratively
That means we try to host from our homes rather than from data centres - a.k.a. 'the cloud' - and we try to host for and with our communities rather than just for ourselves.

![]({attach}images/homebrewserver.svg){: class="img-right"}

## Make space for learning together  
Primarily the homebrewserver.club wants to be a space for learning together. This either means that you are knowledgeable about a topic and willing to share or that you are curious and willing to learn. We are all about the long route that provides grounded understandings instead of mindlessly copy pasting things into the terminal to install software via $current_hip_framework.

## Yes, We’re Config™  
We try help each other out out but we can’t do the work for you. We’re Config, meaning we’re comfy with figuring things out and making mistakes. We take pleasure in researching configurations and in the struggle of getting things working. We gladly lend you a helping hand, but we won’t be able to hold your hand through the whole process.

## Serve from constraints  
Having a homebrew server means owning up to the fact that you are serving from constraints. You don’t have the fastest connection. You use as little power as possible. Your server is some spare laptop you had lying around. You want as little maintenance or worrying as possible. You’re not on 24/7 stand by if there is an issue. All of that is perfectly OK. Knowing this influences our choices in terms of what to run and how.  

## Be an amateur
What works for data centres and the industry does not necessarily work for homebrew servers. As such, the homebrewserver.club documentation won’t be exhaustive. We rather intend to add to existing on-line knowledge, particularly from the perspective of the homebrew server admin.

## Embrace the Feminist Server Manifesto
We subscribe to the principles of the [Feminist Server Manifesto](https://areyoubeingserved.constantvzw.org/Summit_afterlife.xhtml) forwarded by our friends at Constant, a non-profit, artist-run organisation based in Brussels active in the fields of art, media and technology.

## Aspire to broaden participation
By publishing guides and tutorials, we hope to facilitate the means for diverse communities to learn how to set up and run their server according to their needs, goals and principles. For us, this means our channels of communication are an harassment-free experience for everyone, regardless of gender, gender expression, race, ethnicity, religion, sexual orientation, sexual characteristics, disability, age or technological ability. Individuals promoting bigotry will be removed from the channels.
