#!/usr/bin/env python
# -*- coding: utf-8 -*- #
from __future__ import unicode_literals


AUTHOR = 'hbsc & friends'
SITENAME = 'homebrewserver.club'
SITEURL = 'https://homebrewserver.club'

PATH = 'content'

TIMEZONE = 'Europe/Amsterdam'

DEFAULT_LANG = 'en'

#FEED_ALL_ATOM = 'feeds/all.atom.xml'
#FEED_ALL_RSS = 'feeds/all.rss.xml'
FEED_ALL_ATOM = None
CATEGORY_FEED_ATOM = None
TRANSLATION_FEED_ATOM = None
AUTHOR_FEED_ATOM = None
AUTHOR_FEED_RSS = None

DEFAULT_PAGINATION = 10

THEME = 'themes/homebrewtheme'

#Set static output paths
STATIC_PATHS = ['downloads', 'images', 'extra']

EXTRA_PATH_METADATA = {
    'extra/robots.txt': {'path': 'robots.txt'},
    'extra/favicon.ico': {'path': 'favicon.ico'},
    'extra/htaccess': {'path': '.htaccess'}
}

#Pelican Plugins & Markdown extensions
PLUGIN_PATHS = ['plugins']
PLUGINS = ['extract_toc', 'summary','representative_image','addressable_paragraphs']
MARKDOWN = {'extensions':
	['markdown.extensions.codehilite',
	'markdown.extensions.extra',
	'markdown.extensions.smarty',
	'markdown.extensions.toc',
        'markdown.extensions.attr_list'],
	'extension_configs':
	{'markdown.extensions.toc':{
		'title':'Table Of Contents'}
		}
	}

DISPLAY_CATEGORIES_ON_MENU = True
MENUITEMS = [('Manifesto', '/')]

DELETE_OUTPUT_DIRECTORY = True

SLUG_REGEX_SUBSTITUTIONS = [
(r'\s', '-'),]


ARTICLE_ORDER_BY = 'slug'
# Uncomment following line if you want document-relative URLs when developing
#RELATIVE_URLS = True
